package windowsPackage;
import java.awt.*;
import java.awt.event.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.NumberFormat;

import javax.swing.*;

import mainPackage.MainFrame;

public class Customer extends JPanel {
	private JTextField tfFirstName;
	private JTextField tfLastName;
	private JTextField tfCPR;
	private JTextField tfAdress1;
	private JTextField tfAdress2;
	private JTextField tfPhoneNumber;
	private JTextField tfEmail;
	private JTextField tfPassport;
	
	private String customerID;
	
	private MainFrame mainFrame;
	
	public Customer(MainFrame mainFrame) {
		this.mainFrame = mainFrame;
		makeContent();
		addCreateButton();
	}
	
	public Customer() {
		makeContent();
		setBorder(BorderFactory.createTitledBorder("Kunde"));
	}
	
	public Customer(int id, String fn, String ln, String cpr, String a1, String a2, String phone, String mail, String ppn) {
		Integer idInteger = id;
		customerID = idInteger.toString();
		makeContent();
		makeEditContent(id, fn, ln, cpr, a1, a2, phone, mail, ppn);
		addEditButtons();
	}
	
	private void makeEditContent(Integer id, String fn, String ln, String cpr,	String a1, String a2, String phone, String mail, String ppn) {

		tfFirstName.setText(fn);
		tfLastName.setText(ln);
		tfCPR.setText(cpr.toString());
		tfAdress1.setText(a1);
		tfAdress2.setText(a2);
		tfPhoneNumber.setText(phone.toString());
		tfEmail.setText(mail.toString());
		tfPassport.setText(ppn.toString());
	}
	

	private void makeContent() {
		
		setLayout(new BoxLayout(this, 1));
		
		JPanel subPanel = new JPanel();
		
		GridLayout gl1 = new GridLayout();
		
		// Fjerner afstanden mellem labelsne og tekstboksene
		gl1.setHgap(-100);
		
		subPanel.setLayout(gl1);
		
		//Giver lidt afstand og rykker det hele mod venstre; 
		subPanel.setBorder(BorderFactory.createEmptyBorder(0, -200, 0, 0));
		
		// Deler det op i 2 panels, den venstre indeholder labels, hjre indeholder textFields. De der delt op i 2, for at kunne justere afstanden vertikalt og horisontalt individuelt
		JPanel leftPanel = new JPanel();
		JPanel rightPanel = new JPanel();
		
		// GridLayout gl = new GridLayout((labels.size()+1), 1);
		
		GridLayout gl = new GridLayout(8, 1);
		
		leftPanel.setLayout(gl);
		rightPanel.setLayout(new BoxLayout(rightPanel, 1));
		
		JLabel labelFirstName = new JLabel("Fornavn", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfFirstName = new JTextField();
		tfFirstName.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelFirstName);
		rightPanel.add(tfFirstName);
		
		JLabel labelLastName = new JLabel("Efternavn", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfLastName = new JTextField();
		tfLastName.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelLastName);
		rightPanel.add(tfLastName);
		
		JLabel labelCPR = new JLabel("CPR", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfCPR = new JTextField();
		tfCPR.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelCPR);
		rightPanel.add(tfCPR);
		
		JLabel labelAdress1 = new JLabel("Adresse", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfAdress1 = new JTextField();
		tfAdress1.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelAdress1);
		rightPanel.add(tfAdress1);
		
		JLabel labelAdress2 = new JLabel("Postnummer og by", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfAdress2 = new JTextField();
		tfAdress2.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelAdress2);
		rightPanel.add(tfAdress2);
		
		JLabel labelPhoneNumber = new JLabel("Telefon", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfPhoneNumber = new JTextField();
		tfPhoneNumber.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelPhoneNumber);
		rightPanel.add(tfPhoneNumber);
		
		JLabel labelEmail = new JLabel("Email", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfEmail = new JTextField();
		tfEmail.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelEmail);
		rightPanel.add(tfEmail);
		
		JLabel labelPassport = new JLabel("Pas nummer", JLabel.RIGHT);
		rightPanel.add(Box.createVerticalStrut(10));
		tfPassport = new JTextField();
		tfPassport.setMaximumSize(new Dimension(125, 20));
		leftPanel.add(labelPassport);
		rightPanel.add(tfPassport);
		
		subPanel.add(leftPanel);
		subPanel.add(rightPanel);
		
		add(subPanel);
	}
	
	private void addEditButtons() {

		JPanel buttonPanel = new JPanel();
		buttonPanel.add(Box.createVerticalStrut(50));
		buttonPanel.setLayout(new FlowLayout());

		JButton updateCustomer = new JButton("Opdater");
		updateCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(verifyInput() == "true") {
					try {
						Database db = new Database();
						String cmd = "UPDATE Customers SET FirstName='"+tfFirstName.getText()+"', LastName='"+tfLastName.getText()+
								"', CPR='"+tfCPR.getText()+"', Adress1='"+tfAdress1.getText()+"', Adress2='"+tfAdress2.getText()+
								"', PhoneNumber='"+tfPhoneNumber.getText()+"', Mail = '" + tfEmail.getText() + "', PassportNumber='"+tfPassport.getText()+"' WHERE CustomerID='"+customerID+"'";
						db.insert(cmd);
						JOptionPane.showMessageDialog(null, "Kunden er opdateret");
						MainFrame.removeContent();
					}
					catch(SQLException e1) {
						JOptionPane.showMessageDialog(null, "Der skete en fejl! \n Fejlkode: " + e);
					}
				}
				else {
					JOptionPane.showMessageDialog(null, verifyInput());
				}
			}
		});
		JButton deleteCustomer = new JButton("Slet kunde");
		deleteCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					int numberOfSeats = 0;
					Database db = new Database();
					String cmd = "DELETE FROM Customers WHERE CustomerID='"+customerID+"'";
					db.insert(cmd);
					//Sderne skal sttes ledige igen og rejsen antal ledige sder opdateres
					cmd = "SELECT * From Booking WHERE CustomerID='"+customerID+"'";
					ResultSet rs = db.execute(cmd);
					String seatIDs = new String();
					String travelID = new String();
					while(rs.next()) {
						seatIDs = rs.getString("SeatsID");
						travelID = rs.getString("TravelID");
					}
					String cmd1 = "DELETE From Booking WHERE CustomerID='"+customerID+"'";
					db.insert(cmd1);
					String[] seats = seatIDs.split("\\s+");
					for(String s : seats) {
						cmd = "UPDATE `Seats` SET Booked = 0 WHERE SeatsID='"+s+"'";
						db.insert(cmd);
						numberOfSeats++;
					}
					cmd = "UPDATE `Travel` SET FreeSeats = FreeSeats + " +  numberOfSeats + " WHERE TravelID='"+ travelID +"'";
					db.insert(cmd);
					JOptionPane.showMessageDialog(null, "Kunden er slettet");
					MainFrame.removeContent();
				}
				catch(SQLException e2) {
					JOptionPane.showMessageDialog(null, "Der skete en fejl og kunden blev ikke slettet! \n Fejlkode: " + e);
				}
			}
		});
		buttonPanel.add(deleteCustomer);
		buttonPanel.add(updateCustomer);
		add(buttonPanel);
	}
	
	public String verifyInput() {
		
		if(tfFirstName.getText().equals("") || tfLastName.getText().equals("") || tfCPR.getText().equals("")
				|| tfAdress1.getText().equals("") || tfAdress2.getText().equals("") || tfPhoneNumber.getText().equals("") 
				|| tfEmail.getText().equals("") || tfPassport.getText().equals("")) {
			return "Alle felter skal udfyldes";
		}
		String letters = "^[a-zA-Z]+$";
		if(tfCPR.getText().matches(letters) || tfPhoneNumber.getText().matches(letters) || tfPassport.getText().matches(letters)) {
			return "Felterne med CPR, telefonnummer og pasnummer m kun indeholde tal";
		}
		if(tfCPR.getText().length() != 10 || tfPhoneNumber.getText().length() != 8 || tfPassport.getText().length() != 10) {
			return "Felterne med CPR, telefonnummer og pasnummer har en forkert lngde";
		} 
		if(tfFirstName.getText().length() > 100 || tfLastName.getText().length() > 100 || tfAdress1.getText().length() > 100  || tfAdress2.getText().length() > 100  || tfEmail.getText().length() > 100) {
			return "Felterne 'Fornavn', 'Efternavn', 'Adresse', 'By og postnummer' og 'Email' m ikke vre lngere end 100 karakterer ";
		}
		
		return "true";
	}
	
	public String getInput() {
		String values = tfFirstName.getText() + "', '" + tfLastName.getText() + "', '" + tfCPR.getText() + "', '" + tfAdress1.getText() + "', '" + tfAdress2.getText() + "', '" + tfPhoneNumber.getText() + "', '" + tfEmail.getText() + "', '" + tfPassport.getText();
		return values;
	}
	
	private void addCreateButton() {
		JPanel buttonPanel = new JPanel();
		buttonPanel.add(Box.createVerticalStrut(50));
		buttonPanel.setLayout(new FlowLayout());
		
		JButton createCustomer = new JButton("Opret");
		
		createCustomer.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				createCustomer();
			}
		});

		buttonPanel.add(createCustomer);
		add(buttonPanel);
	}

	public void createCustomer() {
		if(verifyInput() == "true") {
			try {
				Database db = new Database();
				String cmd = "INSERT INTO Customers (FirstName, LastName, CPR, Adress1, Adress2, PhoneNumber, Mail, PassportNumber) VALUES('"  + getInput() + "')";
				db.insert(cmd);
				JOptionPane.showMessageDialog(null, "Kunden er oprettet");
				MainFrame.removeContent();
			}
			catch(SQLException e3) {
				JOptionPane.showMessageDialog(null, "Der skete en fejl og kunden blev ikke oprettet! \n Fejlkode: " + e3);
			}
		}
			else {
				JOptionPane.showMessageDialog(null, verifyInput());
			} 
		}

	//Setter til Unit test
	public void setFirstName(String s) {
		tfFirstName.setText(s);
	}
	public void setLastName(String s) {
		tfLastName.setText(s);
	}
	public void setCPR(String s) {
		tfCPR.setText(s);
	}
	public void setAdress1(String s) {
		tfAdress1.setText(s);
	}
	public void setAdress2(String s) {
		tfAdress2.setText(s);
	}
	public void setPhoneNumber(String s) {
		tfPhoneNumber.setText(s);
	}
	public void setEmail(String s) {
		tfEmail.setText(s);
	}
	public void setPassportNumber(String s) {
		tfPassport.setText(s);
	}
	
	
}