package windowsPackage;

import java.awt.*;
import java.awt.event.*;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.*;

import javax.swing.*;

public class Search extends Observable {
	private JFrame mf;
	private JPanel panel;
	private JPanel tempPanel;
	private JPanel topPanel;

	//sgefelter i forbindelse med booking search
	private JTextField bookingNrTF = new JTextField();
	private JTextField bookingToTF = new JTextField();
	private JTextField bookingFromTF = new JTextField();
	private JTextField travelNrTF = new JTextField(); 
	private JTextField seatNrTF = new JTextField();
	private JTextField customerNrTF = new JTextField();
	private JTextField firstNameBookingTF = new JTextField();
	private JTextField lastNameBookingTF = new JTextField();
	private JPanel searchResultPanel;
	//private Integer tempTravelID;
	//sgefelter i forbindelse med customer search
	private JTextField customerFirstNameTF = new JTextField();
	private JTextField customerLastNameTF = new JTextField();
	private JTextField customerCprTF = new JTextField();
	private JTextField customerAdressTF = new JTextField();
	private JTextField customerCityTF = new JTextField();
	private JTextField customerPhoneNumberTF = new JTextField();
	private JTextField customerMailTF = new JTextField();
	//sgefelter i forbindelse med travel search
	private JTextField travelFromTF = new JTextField();
	private JTextField travelToTF = new JTextField();
	private JTextField travelDeparture1TF = new JTextField();
	private JTextField travelDeparture2TF = new JTextField();
	//sgefelter i forbindelse med edit travel search
	private JTextField editTravelTravelNumberTF = new JTextField();
	private JTextField editTravelFlightNumberTF = new JTextField();
	private JTextField editTravelFromTF = new JTextField();
	private JTextField editTravelToTF = new JTextField();
	private JTextField editTravelDepartureTF = new JTextField();
	private JPanel searchPanel;
	private final int searchMethod;
	private ArrayList<String> labelNames;
	private ArrayList<String> resultSetNames;
	private ArrayList<JTextField> tfNames;
	private ResultSet rs = null;

	private SearchString searchString = new SearchString();	

	public Search(int i, CustomerSelect cms, JFrame mainFrame) {
		addObserver(cms);
		topPanel = new JPanel();
		topPanel.setBorder(BorderFactory.createTitledBorder("Sg efter kunde"));
		searchMethod = i;
		topPanel.setLayout(new BorderLayout());
		mf = mainFrame;
		searchPanel = new JPanel();
		searchPanel.setLayout(new BorderLayout());
		String[] labelNamesArray = new String[] { "Fornavn", "Efternavn", "CPR", "Adresse", "By", "Telefon", "Mail" };
		labelNames = new ArrayList<String>(Arrays.asList(labelNamesArray));
		JTextField[] tfNamesArray = new JTextField[] { customerFirstNameTF, customerLastNameTF, customerCprTF, customerAdressTF, customerCityTF, customerPhoneNumberTF, customerMailTF };
		tfNames = new ArrayList<JTextField>(Arrays.asList(tfNamesArray));
		String[] resultSetNamesArray = new String[] { "Kunde nr", "Fornavn", "Efternavn", "CPR", "Adresse", "By", "Telefon", "Mail", "Pasnummer" };
		resultSetNames = new ArrayList<String>(Arrays.asList(resultSetNamesArray));
		searchPanel();
		searchPanel.add(panel, BorderLayout.SOUTH);
		topPanel.add(searchPanel, BorderLayout.NORTH);
	}

	/**
	 * Creates the search menu.
	 * 1 = Booking
	 * 2 = Customer
	 * 3 = Travel
	 * 4 = Edit travel
	 * 5 = SelectCustomer
	 * @param i The number of the menu (see description above).
	 */
	public Search(int i, JFrame mainFrame) {
		topPanel = new JPanel();
		searchMethod = i;
		topPanel.setLayout(new BorderLayout());
		mf = mainFrame;
		searchPanel = new JPanel();
		searchPanel.setLayout(new BorderLayout());
		if(i == 1) {
			topPanel.setBorder(BorderFactory.createTitledBorder("Rediger booking"));
			String[] labelNamesArray = new String[] { "Booking nr", "Fra", "Til", "Kundens fornavn", "Kundens efternavn", "Rejse nr", "Sde nr", "Kunde nr"};
			labelNames = new ArrayList<String>(Arrays.asList(labelNamesArray));
			JTextField[] tfNamesArray = new JTextField[] { bookingNrTF, bookingFromTF, bookingToTF, firstNameBookingTF, lastNameBookingTF, travelNrTF, seatNrTF, customerNrTF };
			tfNames = new ArrayList<JTextField>(Arrays.asList(tfNamesArray));
			String[] resultSetNamesArray = new String[] { "Booking nr", "Rejse nr", "Sde nr", "Kunde nr", "Fornavn", "Efternavn" };
			resultSetNames = new ArrayList<String>(Arrays.asList(resultSetNamesArray));
		}

		if(i == 2) {
			topPanel.setBorder(BorderFactory.createTitledBorder("Rediger kunde"));
			String[] labelNamesArray = new String[] { "Fornavn", "Efternavn", "CPR", "Adresse", "By", "Telefon", "Mail" };
			labelNames = new ArrayList<String>(Arrays.asList(labelNamesArray));
			JTextField[] tfNamesArray = new JTextField[] { customerFirstNameTF, customerLastNameTF, customerCprTF, customerAdressTF, customerCityTF, customerPhoneNumberTF, customerMailTF };
			tfNames = new ArrayList<JTextField>(Arrays.asList(tfNamesArray));
			String[] resultSetNamesArray = new String[] { "Kunde nr", "Fornavn", "Efternavn", "CPR", "Adresse", "By", "Telefon", "Mail", "Pasnummer" };
			resultSetNames = new ArrayList<String>(Arrays.asList(resultSetNamesArray));


		}

		if(i == 3) {
			topPanel.setBorder(BorderFactory.createTitledBorder("Sg efter rejse"));
			String[] labelNamesArray = new String[] { "Afgang fra", "Destination", "Afgangsdato mellem (yyyy-mm-dd)"};
			labelNames = new ArrayList<String>(Arrays.asList(labelNamesArray));
			JTextField[] tfNamesArray = new JTextField[] { travelFromTF, travelToTF, travelDeparture1TF };
			tfNames = new ArrayList<JTextField>(Arrays.asList(tfNamesArray));
			String[] resultSetNamesArray = new String[] { "Rejse nr", "Fly nr", "Fra", "Til", "Afgang", "Ankomst", "Antal ledige sder:" };
			resultSetNames = new ArrayList<String>(Arrays.asList(resultSetNamesArray));
		}

		if(i == 4) {
			topPanel.setBorder(BorderFactory.createTitledBorder("Rediger rejse"));
			String[] labelNamesArray = new String[] { "Rejse nr", "Fly nr", "Afgang fra", "Destination", "Afgangsdato" };
			labelNames = new ArrayList<String>(Arrays.asList(labelNamesArray));
			JTextField[] tfNamesArray = new JTextField[] { editTravelTravelNumberTF, editTravelFlightNumberTF, editTravelFromTF, editTravelToTF, editTravelDepartureTF };
			tfNames = new ArrayList<JTextField>(Arrays.asList(tfNamesArray));

			String[] resultSetNamesArray = new String[] { "Rejse nr", "Fly nr", "Afgang fra", "Destination", "Afgangstid", "Ankomsttid", "Antal ledige sder" };
			resultSetNames = new ArrayList<String>(Arrays.asList(resultSetNamesArray));


		}

		searchPanel();
		searchPanel.add(panel, BorderLayout.SOUTH);
		topPanel.add(searchPanel, BorderLayout.NORTH);
	}

	private void searchPanel() {

		panel = new JPanel();
		panel.setLayout(new BorderLayout());
		JPanel textPanel = new JPanel();
		textPanel.setLayout(new GridLayout(0, 2));

		Iterator<String> itLabel = labelNames.iterator();
		Iterator<JTextField> itTf = tfNames.iterator();


		JPanel datePanel = new JPanel(new GridLayout(0,2));

		while(itLabel.hasNext() || itTf.hasNext()) {
			String next = null;
			if(itLabel.hasNext()) {
				next = itLabel.next();
				textPanel.add(new JLabel(next));
			}
			if(itTf.hasNext()) {
				if(next.equals("Afgangsdato mellem (yyyy-mm-dd)")) {
					datePanel.add(travelDeparture1TF);
					datePanel.add(travelDeparture2TF);
					textPanel.add(datePanel);
					itTf.next();
				}
				else {
					textPanel.add(itTf.next());
				}
			}

		}

		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridLayout(1, 2));
		JButton rydButton = new JButton("Ryd felter");
		JButton searchButton = new JButton("Sg");
		rydButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				clearAllFields();
			}
		});
		searchButton.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				try {
					if(searchMethod == 1) rs = getMatchingBookings();
					if(searchMethod == 2 || searchMethod == 5) {
						String cmd = searchString.generateCustomerString(customerFirstNameTF.getText(), 
								customerLastNameTF.getText(), customerCprTF.getText(), customerAdressTF.getText(), 
								customerCityTF.getText(), customerPhoneNumberTF.getText(), customerMailTF.getText());
						rs = getMatchingResults(cmd);
					}

					if(searchMethod == 3) {
						String cmd = searchString.generateTravelSearchString(travelDeparture1TF.getText(),
								travelDeparture2TF.getText(), travelFromTF.getText(), travelToTF.getText());
						rs = getMatchingResults(cmd);
					}

					if(searchMethod == 4) {
						String cmd = searchString.generateEditTravelSearchString(editTravelTravelNumberTF.getText(),
								editTravelFlightNumberTF.getText(), editTravelFromTF.getText(), editTravelToTF.getText(), 
								editTravelDepartureTF.getText());
						rs = getMatchingResults(cmd);
					}

					if(tempPanel != null) {
						panel.remove(tempPanel);
					}

					createResults(rs, resultSetNames);
					mf.pack();
				}
				catch(SQLException e2) {
					JOptionPane.showMessageDialog(null, "Du skal vre forbundet til internettet!");
				}
				}
			});
		buttonPanel.add(rydButton);
		buttonPanel.add(searchButton);

		panel.add(buttonPanel, BorderLayout.CENTER);
		panel.add(textPanel, BorderLayout.NORTH);

	}

	private void createResults(ResultSet rs, ArrayList<String> resultNames) {
		//lav resultPanel

		JPanel resultPanel = new JPanel(new GridLayout(1,0));

		Iterator<String> resultLabels = resultNames.iterator();
		while(resultLabels.hasNext()) {
			JLabel s = new JLabel(resultLabels.next(), SwingConstants.CENTER);
			s.setBorder(BorderFactory.createRaisedBevelBorder());
			resultPanel.add(s);
		}
		JLabel s = new JLabel("");
		resultPanel.add(s);

		//lav resultaterne
		searchResultPanel = new JPanel();

		try {
			while(rs.next()) {
				if(searchMethod == 1) {
					searchResultPanel.setLayout(new GridLayout(0,7));
					final Integer bookingID = rs.getInt("BookingID");
					searchResultPanel.add(new JLabel(bookingID.toString()));
					final Integer travelID = rs.getInt("TravelID");
					searchResultPanel.add(new JLabel(travelID.toString()));
					final String seatsID = rs.getString("SeatsID");
					searchResultPanel.add(new JLabel(seatsID));
					final Integer customerID = rs.getInt("CustomerID");
					searchResultPanel.add(new JLabel(customerID.toString()));

					//Henter fornavn og efternavn for hver booking
					String cmd = "SELECT `FirstName`, `LastName` FROM Customers WHERE `CustomerID` = '"+customerID.toString()+"'";
					Database db = new Database();
					ResultSet rs1 = db.execute(cmd);
					String firstNameBooking = new String();
					String lastNameBooking = new String();
					while(rs1.next()) {
						firstNameBooking = rs1.getString("FirstName");
						lastNameBooking = rs1.getString("LastName");
					}
					searchResultPanel.add(new JLabel(firstNameBooking));
					searchResultPanel.add(new JLabel(lastNameBooking));

					System.out.println(bookingID.toString()+" "+travelID.toString()+" "+seatsID+" "+customerID.toString()+
							" "+firstNameBooking+" "+lastNameBooking);	

					final JButton b1 = new JButton("Vlg");
					searchResultPanel.add(b1);
					b1.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							System.out.println("Booking nr "+bookingID+" er valgt");
							panel.removeAll();
							panel.add(new Booking(bookingID, travelID, seatsID, customerID), BorderLayout.SOUTH);
							mf.pack();
						}
					});	
				}


				if(searchMethod == 2 || searchMethod == 5) {
					searchResultPanel.setLayout(new GridLayout(0,10));
					final Integer a = rs.getInt("CustomerID");
					searchResultPanel.add(new JLabel(a.toString(), JLabel.CENTER));
					final JLabel firstName = new JLabel(rs.getString("FirstName"), JLabel.CENTER);
					searchResultPanel.add(firstName);
					final JLabel lastName = new JLabel(rs.getString("LastName"), JLabel.CENTER);
					searchResultPanel.add(lastName);
					final JLabel b = new JLabel(rs.getString("CPR"), JLabel.CENTER);
					searchResultPanel.add(b);
					final JLabel adress1 = new JLabel(rs.getString("Adress1"), JLabel.CENTER);
					searchResultPanel.add(adress1);
					final JLabel adress2 = new JLabel(rs.getString("Adress2"), JLabel.CENTER);
					searchResultPanel.add(adress2);
					final JLabel c = new JLabel(rs.getString("PhoneNumber"), JLabel.CENTER);
					searchResultPanel.add(c);
					final JLabel mail = new JLabel(rs.getString("Mail"), JLabel.CENTER);
					searchResultPanel.add(mail);
					final JLabel d = new JLabel(rs.getString("PassportNumber"), JLabel.CENTER);
					searchResultPanel.add(d);
					
					final JButton b1 = new JButton("Vlg");
					searchResultPanel.add(b1);
					b1.addActionListener(new ActionListener() {
						public void actionPerformed(ActionEvent e) {
							topPanel.remove(searchPanel);
							if(searchMethod == 5) {
								setChanged();
								String send = a + " " + firstName.getText() + " " + lastName.getText();
								notifyObservers(send);
							}
							topPanel.add(new Customer(a, firstName.getText(), lastName.getText(), b.getText(), 
									adress1.getText(), adress2.getText(), c.getText(), mail.getText(), d.getText()));
							mf.pack();
						}
					});
					System.out.println(a.toString() +" "+ rs.getString("FirstName") +" "+ rs.getString("LastName") +" "+  b.getText() + " " 
							+ rs.getString("Adress1") +" "+ rs.getString("Adress2") +" "+ c.getText() +" "+ rs.getString("Mail") +" "+ d.getText());						
				}

				if(searchMethod == 3 || searchMethod == 4) {
					final Integer numberOfFreeSeats = rs.getInt("FreeSeats");

					if(!(searchMethod == 3 && numberOfFreeSeats == 0)) {
						searchResultPanel.setLayout(new GridLayout(0,8));
						final Integer x = rs.getInt("TravelID");
						searchResultPanel.add(new JLabel(x.toString(), JLabel.CENTER));
						final Integer y = rs.getInt("AirPlaneID");
						searchResultPanel.add(new JLabel(y.toString(), JLabel.CENTER));
						final String from = rs.getString("From");
						searchResultPanel.add(new JLabel(from, JLabel.CENTER));
						final String to = rs.getString("To");
						searchResultPanel.add(new JLabel(to, JLabel.CENTER));
						//laver timestamp om til en String
						SimpleDateFormat sdt = new SimpleDateFormat("yyyy.MM.dd HH:mm");
						Timestamp dTs = rs.getTimestamp("Departure");
						final String departure = sdt.format(dTs);
						searchResultPanel.add(new JLabel(departure));
						Timestamp aTs = rs.getTimestamp("Arrival");
						final String arrival = sdt.format(aTs);
						searchResultPanel.add(new JLabel(arrival));

						searchResultPanel.add(new JLabel(numberOfFreeSeats.toString()));

						final JButton b1 = new JButton("Vlg");
						b1.addActionListener(new ActionListener() {
							public void actionPerformed(ActionEvent e) {
								topPanel.remove(searchPanel);
								if(searchMethod == 3) {
									topPanel.add(new Booking(x, y, from, to, departure, arrival));
								}
								else if(searchMethod == 4)
									try {
										topPanel.add(new Travel(x, y, from, to, departure, arrival));
									} catch (SQLException e1) {
										JOptionPane.showMessageDialog(null, "Der skete en fejl! \n Fejlkode: " + e1);
									}
								mf.pack();
							}
						});
						searchResultPanel.add(b1);
						System.out.println(rs.getInt(1) +" "+ rs.getInt(2) +" "+ rs.getString(3) +" "
								+ rs.getString(4) +" "+ sdt.format(rs.getTimestamp(5)) +" "+ sdt.format(rs.getTimestamp(6)));

					}
				}
			}
		}
		catch(SQLException e1) {
			JOptionPane.showMessageDialog(null, "Der skete en fejl! \n Fejlkode: " + e1);
		}

		//scrollpane til sgeresultaterne
		JScrollPane scrollPane = new JScrollPane(searchResultPanel);
		scrollPane.setPreferredSize(new Dimension(1200,93));

		//tempPanel til at holde sgepanelet og sgeresultatpanelet.
		tempPanel = new JPanel(new BorderLayout());
		tempPanel.setBorder(BorderFactory.createTitledBorder("Sgeresultater"));
		tempPanel.add(resultPanel, BorderLayout.NORTH);
		tempPanel.add(scrollPane, BorderLayout.SOUTH);

		panel.add(tempPanel, BorderLayout.SOUTH);
	}

	private ResultSet getMatchingResults(String cmd) throws SQLException {
			Database db = new Database();
			return db.execute(cmd);
	}


	private ResultSet getMatchingBookings() throws SQLException {
			Database db = new Database();		
			return db.execute(searchString.generateBookingString(bookingFromTF.getText(), bookingToTF.getText(), 
					bookingNrTF.getText(), travelNrTF.getText(), seatNrTF.getText(), customerNrTF.getText(), 
					firstNameBookingTF.getText(), lastNameBookingTF.getText()));
	}

	public void clearAllFields() {
		editTravelTravelNumberTF.setText("");
		editTravelFlightNumberTF.setText("");
		editTravelFromTF.setText("");
		editTravelToTF.setText("");
		editTravelDepartureTF.setText("");
		customerFirstNameTF.setText("");
		customerLastNameTF.setText("");
		customerCprTF.setText("");
		customerAdressTF.setText("");
		customerCityTF.setText("");
		customerPhoneNumberTF.setText("");
		customerMailTF.setText("");
		travelFromTF.setText("");
		travelToTF.setText("");
		travelDeparture1TF.setText("");
		travelDeparture2TF.setText("");
		bookingNrTF.setText("");
		bookingFromTF.setText("");
		bookingToTF.setText("");
		travelNrTF.setText("");
		seatNrTF.setText("");
		customerNrTF.setText("");
	}

	public JPanel getTopPanel() {
		return topPanel;
	}
}
